精华内容
下载资源
问答
  • 1.判断变量复制代码 代码如下:read -p "input a word :" wordif [ ! -n "$word" ] ;thenecho "you have not input a word!...判断输入参数复制代码 代码如下:#!/bin/bashif [ ! -n "$1" ] ;thenecho ...

    1.判断变量

    复制代码 代码如下:

    read -p "input a word :" word

    if  [ ! -n "$word" ] ;then

    echo "you have not input a word!"

    else

    echo "the word you input is $word"

    fi

    2.判断输入参数

    复制代码 代码如下:

    #!/bin/bash

    if [ ! -n "$1" ] ;then

    echo "you have not input a word!"

    else

    echo "the word you input is $1"

    fi

    以下未验证。

    3. 直接通过变量判断

    如下所示:得到的结果为: IS NULL

    复制代码 代码如下:

    #!/bin/sh

    para1=

    if [ ! $para1 ]; then

    echo "IS NULL"

    else

    echo "NOT NULL"

    fi

    4. 使用test判断

    得到的结果就是: dmin is not set!

    复制代码 代码如下:

    #!/bin/sh

    dmin=

    if test -z "$dmin"

    then

    echo "dmin is not set!"

    else

    echo "dmin is set !"

    fi

    5. 使用""判断

    复制代码 代码如下:

    #!/bin/sh

    dmin=

    if [ "$dmin" = "" ]

    then

    echo "dmin is not set!"

    else

    echo "dmin is set !"

    fi

    下面是我在某项目中写的一点脚本代码, 用在系统启动时:

    复制代码 代码如下:

    #! /bin/bash

    echo "Input Param Is [$1]"

    if [ ! -n "$1" ] ;then

    echo "you have not input a null word!"

    ./app1;./app12;./app123

    elif [ $1 -eq 2 ];then

    ./app12;./app123

    elif [ $1 -eq 90 ];then

    echo "yy";

    fi

    展开全文
  • 判断变量read -p "input a word :" wordif [ ! -n "$word" ] ;thenecho "you have not ..."elseecho "the word you input is $word"fi判断输入参数#!/bin/bashif [ ! -n "$1" ] ;thenecho "you have not input a wo...

    判断变量

    read -p "input a word :" word

    if [ ! -n "$word" ] ;then

    echo "you have not input a word!"

    else

    echo "the word you input is $word"

    fi

    判断输入参数

    #!/bin/bash

    if [ ! -n "$1" ] ;then

    echo "you have not input a word!"

    else

    echo "the word you input is $1"

    fi

    以下未验证,转自http://blog.csdn.net/lllxy/article/details/3255554

    2. 直接通过变量判断

    如下所示:得到的结果为: IS NULL

    #!/bin/sh

    para1=

    if [ ! $para1 ]; then

    echo "IS NULL"

    else

    echo "NOT NULL"

    fi

    3. 使用test判断

    得到的结果就是: dmin is not set!

    #!/bin/sh

    dmin=

    if test -z "$dmin"

    then

    echo "dmin is not set!"

    else

    echo "dmin is set !"

    fi

    4. 使用""判断

    #!/bin/sh

    dmin=

    if [ "$dmin" = "" ]

    then

    echo "dmin is not set!"

    else

    echo "dmin is set !"

    fi

    下面是我在某项目中写的一点脚本代码, 用在系统启动时:

    #! /bin/bash

    echo "Input Param Is [$1]"

    if [ ! -n "$1" ] ;then

    echo "you have not input a null word!"

    ./app1;./app12;./app123

    elif [ $1 -eq 2 ];then

    ./app12;./app123

    elif [ $1 -eq 90 ];then

    echo "yy";

    fi

    展开全文
  • #用法:Usag: [参数列表]# checknum.sh#检测参数个数是否合法if test $# -lt 1 #当参数个数小于2时,也就是没有整数输入,报错。then echo "参数错误,使用方法:checknum n1 n2 n3... (一个参数序列)。"exit 1 ...

    #!/bin/sh

    #这个脚本用来判断后面的参数的种类(非数字,奇数,偶数,浮点数)。

    #用法:Usag: [参数列表]

    # checknum.sh

    #检测参数个数是否合法

    if test $# -lt 1     #当参数个数小于2时,也就是没有整数输入,报错。

    then echo "参数错误,使用方法:checknum n1 n2 n3... (一个参数序列)。"

    exit 1               #直接退出

    fi

    #判断参数种类

    forstr in $*         #用一个临时变量str,从参数列表中依次次取出各个参数。

    do

    {

    #将取出的参数传给程序bc,用它来检测这个参数是否为数字,并将错误信息重定向。

    var=$(echo$str | bc 2>/dev/null)

    #如果传入的参数是一个数字,bc返回值就是这个数,否则不是,通过这个可以判断参数是否为数字。

    if ["$var" != "$str" ] #如果bc返回值与这个参数相同,则参数一定是数字,反之则不是。

    then {

    echo "$str 不是一个数字。"

    }

    #如果参数是数字,则只需要查找是否含有小数点来判断是否为浮点数。

    elif echo $str|grep "\." >/dev/null 2>&1

    then {

    echo "$str 是一个浮点数。"

    }

    else {

    #如果这个参数是一个整数,将他模2,余数为0则是偶数,为1则为奇数。

    if test `expr $str % 2` -eq 0

    then echo "$str 是一个偶数。"

    else echo "$str 是一个奇数。"

    fi

    }

    fi

    }

    done

    exit

    展开全文
  • 一、条件选择、判断 1、条件选择if (1)用法格式 if 判断条件 1 ; then 条件真的分支代码 ...逐条件进行判断,第一次遇“真”条件时,执行其分支,而后结束整个if。 (2)经典案例: #判断年纪 #!/...

    一、条件选择、判断

    1、条件选择if

    (1)用法格式

    if 判断条件 1 ; then
      条件为真的分支代码
    elif 判断条件 2 ; then
      条件为真的分支代码
    elif 判断条件 3 ; then
      条件为真的分支代码
    else
      以上条件都为假的分支代码
    fi
    
    

    逐条件进行判断,第一次遇为“真”条件时,执行其分支,而后结束整个if。

    (2)经典案例:

    #判断年纪
    #!/bin/bash
    read -p "Please input your age: " age
    if [[ $age =~ [^0-9] ]] ;then
        echo "please input a int"
        exit 10
    elif [ $age -ge 150 ];then
        echo "your age is wrong"
        exit 20
    elif [ $age -gt 18 ];then
        echo "good good work,day day up"
    else
        echo "good good study,day day up"
    fi
    
    

    分析:请输入年纪,先判断输入的是否含有除数字以外的字符,有,就报错;没有,继续判断是否小于150,是否大于18。

    #判断分数
    #!/bin/bash
    read -p "Please input your score: " score
    if [[ $score =~ [^0-9] ]] ;then
        echo "please input a int"
        exit 10
    elif [ $score -gt 100 ];then
        echo "Your score is wrong"
        exit 20
    elif [ $score -ge 85 ];then
        echo "Your score is very good"
    elif [ $score -ge 60 ];then
        echo "Your score is soso"
    else
        echo "You are loser"
    fi
    
    

    分析:请输入成绩,先判断输入的是否含有除数字以外的字符,有,就报错;没有,继续判断是否大于100,是否大于85,是否大于60。

    2、条件判断 case

    (1)用法格式

    case $name in;
    PART1)
      cmd
      ;;
    PART2)
      cmd
      ;;
    *)
      cmd
      ;;
    esac
    
    

    注意:case 支持glob 风格的通配符:

      *: 任意长度任意字符
      ?: 任意单个字符
      [] :指定范围内的任意单个字符
      a|b: a 或 b
    
    

    (2)案例:

    #判断yes or no
    
    #!/bin/bash
    read -p "Please input yes or no: " anw
    case $anw in
    [yY][eE][sS]|[yY])
        echo yes
        ;;
    [nN][oO]|[nN])
        echo no
        ;;
    *)
        echo false
        ;;
    esac
    
    

    二、四个循环

    1、for

    (1)用法格式

    ① for name in 列表 ;do
      循环体
    done
    ② for (( exp1; exp2; exp3 )) ;do
      cmd
    done
    
    

    (2)案例

    #求出(1+2+...+n)的总和
    sum=0
    read -p "Please input a positive integer: " num
    if [[ $num =~ [^0-9] ]] ;then
        echo "input error"
    elif [[ $num -eq 0 ]] ;then
        echo "input error"
    else
        for i in `seq 1 $num` ;do
            sum=$[$sum+$i]
        done
        echo $sum
    fi
    unset zhi  
    
    

    分析:sum初始值为0,请输入一个数,先判断输入的是否含有除数字以外的字符,有,就报错;没有判断是否为0,不为0进入for循环,i的范围为1~输入的数,每次的循环为sum=sum+i,循环结束,最后输出sum的值。

    #求出(1+2+...+100)的总和
    
    for (( i=1,num=0;i<=100;i++ ));do
            [ $[i%2] -eq 1 ] && let sum+=i
    done
    echo sum=$sum
     分析:i=1,num=0;当i<=100,进入循环,若i÷2取余=1,则sum=sum+i,i=i+1。
    
    

    2、while

    (1)用法格式

    while 循环控制条件 ;do
      循环
    done
    
    

    循环控制条件;进入循环之前,先做一次判断;每一次循环之后会再次做判断;条件为“true” ,则执行一次循环;直到条件测试状态为“false” 终止循环

    (2)特殊用法(遍历文件的每一行):

    while read line; do控制变量初始化
      循环体
    done < /PATH/FROM/SOMEFILE
    或cat /PATH/FROM/SOMEFILE | while read line; do
      循环体
    done
    
    

    依次读取/PATH/FROM/SOMEFILE文件中的每一行,且将行赋值给变量line

    (3)案例:

    #100以内所有正奇数之和
    sum=0
    i=1
    while [ $i -le 100 ] ;do
    if [ $[$i%2] -ne 0 ];then
        let sum+=i
        let i++
    else
        let i++
    fi
    done
    echo "sum is $sum"
    
    

    分析:sum初始值为0,i的初始值为1;请输入一个数,先判断输入的是否含有除数字以外的字符,有,就报错;没有当i<100时,进入循环,判断 i÷2取余 是否不为0,不为0时为奇数,sum=sum+i,i+1,为0,i+1;循环结束,最后输出sum的值。

    3、until 循环

    (1)用法

    unitl 循环条件 ;do
      循环
    done
    
    

    进入条件:循环条件为true ;退出条件:循环条件为false;刚好和while相反,所以不常用,用while就行。

    (2)案例

    #监控xiaoming用户,登录就杀死
    until pgrep -u xiaoming &> /dev/null ;do
            sleep 0.5
    done
    pkill -9 -u xiaoming
    
    

    分析:每隔0.5秒扫描,直到发现xiaoming用户登录,杀死这个进程,退出脚本,用于监控用户登录。

    4、select 循环与菜单

    (1)用法

    select variable in list
    do
      循环体命令
    done
    
    
    • ① select 循环主要用于创建菜单,按数字顺序排列的示菜单项将显示在标准错误上,并显示PS3 提示符,等待用户输入
    • ② 用户输入菜单列表中的某个数字,执行相应的命令
    • ③ 用户输入被保存在内置变量 REPLY 中
    • ④ select 是个无限循环,因此要记住用 break 命令退出循环,或用 exit 按 命令终止脚本。也可以按 ctrl+c退出循环
    • ⑤ select 和 经常和 case 联合使用
    • ⑥ 与for循环类似,可以省略 in list, 此时使用位置参量

    (2)案例

    #生成菜单,并显示选中的价钱
    PS3="Please choose the menu: "
    select menu in mifan huimian jiaozi babaozhou quit
    do
            case $REPLY in
            1|4)
                    echo "the price is 15"
                    ;;
            2|3)
                    echo "the price is 20"
                    ;;
            5)
                    break
                    ;;
            *)
                    echo "no the option"
            esac
    done
    
    

    分析:PS3是select的提示符,自动生成菜单,选择5  break退出循环。

    三、循环里的一些用法

    1、循环控制语句

    (1)语法

    continue [N]:提前结束第N层的本轮循环,而直接进入下一轮判断;最内层为第1层 break [N]:提前结束第N层循环,最内侧为第1层

     例:while CONDTITON1; do
      CMD1
    if CONDITION2; then
      continue / break
    fi
      CMD2
    done
    
    

    (2)案例:

    #①求(1+3+...+49+53+...+100)的和
    
    #!/bin/bash
    sum=0
    for i in {1..100} ;do
            [ $i -eq 51 ] && continue
            [ $[$i%2] -eq 1 ] && { let sum+=i;let i++; }
    done
    echo sum=$sum
    
    

    分析:做1+2+...+100的循环,当i=51时,跳过这次循环,但是继续整个循环,结果为:sum=2449

    #②求(1+3+...+49)的和
    
    #!/bin/bash
    sum=0
    for i in {1..100} ;do
            [ $i -eq 51 ] && break
            [ $[$i%2] -eq 1 ] && { let sum+=i;let i++; }
    done
    echo sum=$sum
    
    

    分析:做1+2+...+100的循环,当i=51时,跳出整个循环,结果为:sum=625

    2、循环控制shift命令

    (1)作用

    用于将参数列表list左移指定次数,最左端的那个参数就从列表中删除,其后边的参数继续进入循环

    (2)案例:

    #①创建指定的多个用户
    
    #!/binbash
    if [ $# -eq 0 ] ;then
            echo "Please input a arg(eg:`basename $0` arg1)"
            exit 1
    else
            while [ -n "$1" ];do
                    useradd $1 &> /dev/null
                    shift
            done
    fi
    
    

    分析:如果没有输入参数(参数的总数为0),提示错误并退出;反之,进入循环;若第一个参数不为空字符,则创建以第一个参数为名的用户,并移除第一个参数,将紧跟的参数左移作为第一个参数,直到没有第一个参数,退出。

    #②打印直角三角形的字符
    
    #!/binbash
    while (( $# > 0 ))
    do
            echo "$*"
            shift
    done
    
    

    3、返回值结果

    true 永远返回成功结果
    : null command ,什么也不干,返回成功结果
    false 永远返回错误结果
    
    

    创建无限循环

    while true ;do
      循环体
    done
    
    

    4、循环中可并行执行,使脚本运行更快

    (1)用法

    for name in 列表 ;do
      {
      循环体
      }&
    done
    wait
    
    

    (2)实例:

    #搜寻自己指定ip(子网掩码为24的)的网段中,UP的ip地址
    read -p "Please input network (eg:192.168.0.0): " net
    echo $net |egrep -o "\<(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\>"
    [ $? -eq 0 ] || ( echo "input error";exit 10 )
    IP=`echo $net |egrep -o "^([0-9]{1,3}\.){3}"`
    for i in {1..254};do
            {
            ping -c 1 -w 1 $IP$i &> /dev/null && \
            echo "$IP$i is up" 
            }&
    
    done
    wait
    
    

    分析:请输入一个IP地址例192.168.37.234,如果格式不是0.0.0.0 则报错退出;正确则进入循环,IP变量的值为192.168.37.  i的范围为1-254,并行ping 192.168.37.1-154,ping通就输出此IP为UP。直到循环结束。

    四、信号捕获trap

    1、用法格式

    trap ' 触发指令' 信号,自定义进程收到系统发出的指定信号后,将执行触发指令,而不会执行原操作
    trap '' 信号,忽略信号的操作
    trap '-' 信号,恢复原信号的操作
    trap -p,列出自定义信号操作
    
    

    信号可以3种表达方法:信号的数字2、全名SIGINT、缩写INT

    2、常用信号

    1) SIGHUP: 无须关闭进程而让其重读配置文件
    2) SIGINT: 中止正在运行的进程;相当于Ctrl+c
    3) SIGQUIT: 相当于ctrl+\
    9) SIGKILL: 强制杀死正在运行的进程
    15) SIGTERM :终止正在运行的进程(默认为15)
    18) SIGCONT :继续运行
    19) SIGSTOP :后台休眠
    9 信号,强制杀死,捕获不住
    
    

     3、案例

    #①打印0-9,ctrl+c不能终止
    #!/bin/bash
    trap 'echo press ctrl+c' 2
    for ((i=0;i<10;i++));do
            sleep 1
            echo $i
    done
    
    

    分析:i=0,当i<10,每休眠1秒,i+1,捕获2信号,并执行echo press ctrl+c

    #②打印0-3,ctrl+c不能终止,3之后恢复,能终止
    
    #!/bin/bash
    trap '' 2
    trap -p
    for ((i=0;i<3;i++));do
            sleep 1
            echo $i
    done
    trap '-' SIGINT
    for ((i=3;i<10;i++));do
            sleep 1
            echo $i
    done
    
    

    分析:i=0,当i<3,每休眠1秒,i+1,捕获2信号;i>3时,解除捕获2信号。

    六、分享几个有意思的小脚本

    1、、echo打印颜色字

    echo -e "\033[31malong\033[0m" 显示红色along
    echo -e "\033[1;31malong\033[0m" 高亮显示红色along
    echo -e "\033[41malong\033[0m" 显示背景色为红色的along
    echo -e "\033[31;5malong\033[0m" 显示闪烁的红色along
    color=$[$[RANDOM%7]+31]
    echo -ne "\033[1;${color};5m*\033[0m" 显示闪烁的随机色along
    
    

    2、9x9乘法表

    #!/bin/bash
    for a in {1..9};do
            for b in `seq 1 $a`;do
                    let c=$a*$b ;echo -e "${a}x${b}=$c\t\c"
            done
            echo    
    done
    
    

    2、彩色等腰三角形

    #!/bin/bash
    read -p "Please input a num: " num
    if [[ $num =~ [^0-9] ]];then
            echo "input error" 
    else
            for i in `seq 1 $num` ;do
                    xing=$[2*$i-1]
                    for j in `seq 1 $[$num-$i]`;do
                            echo -ne " "
                    done
                    for k in `seq 1 $xing`;do
                            color=$[$[RANDOM%7]+31]
                            echo -ne "\033[1;${color};5m*\033[0m"
                    done
                    echo
            done
    fi
    
    

    3、国际象棋棋盘

    #!/bin/bash
    red="\033[1;41m  \033[0m"
    yellow="\033[1;43m  \033[0m"
    
    for i in {1..8};do
            if [ $[i%2] -eq 0 ];then
                    for i in {1..4};do
                            echo -e -n "$red$yellow";
                    done
                    echo
            else
                    for i in {1..4};do
                            echo -e -n "$yellow$red";
                    done
                    echo 
            fi
    done
    
    
    展开全文
  • d 当pathname存在并且是一个目录时返回真-e 当pathname指定的文件或目录存在时返回真-f 当file存在并且是正规文件时返回真-g 当由pathname指定的文件或目录存在并且设置了SGID位时返回真-h 当file存在并且是符号...
  • shell 是操作系统的最外层。...shell中如何判断一个变量是否为空的方法探讨,shell编程中,对参数的错误检查项中,包含了变量是否赋值(即一个变量是否为空),判断变量为空方法如下:1.变量通过” “引号引起来#!/b...
  • 1.脚本功能:提示客户属于一串数字,并判断用户是否进行了输入输入的是否数字#!/bin/bashread -p "enter a number: " number #提示用户输入数字if [ -z $number ];then #判断用户是否输入,如果未输入则打印...
  • 本文内容:判断用户输入参数是否数字在shell中如何进行计算?方式一[root@XiaoPeng scripts]# echo $((1+2))3方式二[root@XiaoPeng scripts]# expr 2 + 35[root@XiaoPeng scripts]#注意:使用方式二的时候,要求...
  • $#代表了命令行的参数数量,可以看以下实例:if [ $# != 1 ] ;...fi位置参数 $1, $2,..., $N,$#代表了命令行的参数数量, $0代表了脚本的名字-ne 不等于-----------------------shell 编程中使用到...
  • shell 判断文件/目录是否为空jfkidear144932015-01-15shell中如何判断一个变量是否为空l_nan365492014-07-14在shell中如何判断一个变量是否为空varyall188622018-01-23linux bash shell 判断目录是否为空的函数10km...
  • 判断一个字符串是否为空的方法: 方法一: if [ "$str" = "" ] #如果str是空字符串则返回真 方法二: if [ x"$str" = x ] #如果...还可以使用 if 与 test 命令的 z 参数,可以判断字符串是否为空 if test -z $str
  • shell 参数个数判断参数判断

    千次阅读 2021-01-13 22:34:45
    then echo "no argument" fi 二、执行shell文件时,若脚本无参数,则第一个参数为空值。 if [ "$1" ]; then echo "no argument" fi 或 if [ -z "$1" ]; then echo "no argument" fi 说明:$#的数量即传递给脚本的...
  • 第一个-n是shell的测试标志,对后面的串"`sed -n '/^[0-9][0-9]*$/p'`" 进行测试,如果非空,则结果真。 sed默认会显示所有输入行信息的,sed 的“-n”选项是让sed不要显示,而只显示我们所需要的内容:即后面的...
  • 我需要检查输入参数的存在性。我有下面的剧本if ["$1" -gt"-1" ]then echo hifi我得到[: : integer expression expected如何首先检查输入参数1以查看它是否存在?...或者,您可以检查参数是否为空字符串或类似...
  • 如果参数的第一个参数长度0.结果返回true,否则返回false -z “$1” 如果参数的第一个参数长度0.结果返回false,否则返回true [ $? -eq 0 ] 是判断if语句的上一个命令执行如果成功就执行if中的语句,注意:...
  • 工作中常会用到shell脚本,总结一些常用的简单操作。 1. 判断传入参数的个数 #!/bin/bash # author:geekzw if [ $# -eq 2 ]; then echo "$1 $2" exit else echo "错误" fi 运行结果
  • Java——复制txt文件 将源文件复制到目标文件,同时输出源文件内容,需要提供一个源文件和目标文件路径参数(如果不存在则自动创建) public static void copyTxt(String sourceFile, S ... char和varchar的区别 在建立...
  • 本文内容:判断用户输入参数是否数字在shell中如何进行计算?方式一[root@XiaoPeng scripts]# echo $((1+2))3方式二[root@XiaoPeng scripts]# expr 2 + 35[root@XiaoPeng scripts]#注意:使用方式二的时候,要求...
  • #!/bin/bash #作者:魏波 #时间:2017.02.04 if [ -n "$1" ]; then if [[ $1 =~ ^[0-9]+$ ]]; then echo "$1 Is Number." else echo "$1 No Number." fi...表示$1为空 即:if [ -n str1 ]当串的长度大于0时为真(串非空)
  • shell 判断语句流程控制 "if" 表达式 如果条件真则执行then后面的部分: if ....; then....elif ....; then....else....fi大多数情况下,可以使用测试命令来对条件进行测试。比如可以比较字符串、判断文件是否存在...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 90,725
精华内容 36,290
关键字:

shell判断输入参数为空